'use strict';window.addEventListener('largetextenabledchanged',function(){document.body.classList.toggle('large-text',navigator.largeTextEnabled);});document.body.classList.toggle('large-text',navigator.largeTextEnabled);if(document.location.hash==='#activity'){navigator.mozSetMessageHandler('activity',function(activity){function flatten(arr){return arr&&arr.length?arr[0]:null;}
var data=activity.source.data;data.blob=flatten(data.blobs);data.metadata=flatten(data.metadata);data.name=flatten(data.filenames);handleShare(data,function(command,details){switch(command){case'save':activity.postResult({});break;case'cancel':activity.postError('pick cancelled');break;case'error':activity.postError('pick error');break;}});});}
else{window.addEventListener('visibilitychange',function(){if(document.hidden){window.close();}});window.addEventListener('message',function(event){if(event.origin!==window.location.origin){console.error('Couldn\'t recieve message: origins don\'t match',event.origin,window.location.origin);return;}
handleShare(event.data,function(command,details){event.source.postMessage({command:command,details:details},event.origin);window.close();});});}
function handleShare(data,callback){navigator.mozL10n.once(function(){var _=navigator.mozL10n.get;function showError(title,message,okCallback){var okButton={title:'ok',callback:function(){CustomDialog.hide();okCallback();}};CustomDialog.show(title,message,okButton);}
var preview=document.getElementById('preview');var checkBox=document.getElementById('default-switch');var songtitle;if(data.metadata&&data.metadata.title){songtitle=data.metadata.title;}
else if(data.name){songtitle=data.name;}
else{songtitle=_('ringtone-untitled');}
var subtitle='';if(data.metadata&&data.metadata.artist){subtitle=data.metadata.artist;}
document.getElementById('songtitle').textContent=songtitle;document.getElementById('artist').textContent=subtitle;if(data.metadata&&data.metadata.picture){if(!subtitle){document.getElementById('artist').textContent='\u00a0';document.querySelector('.small').hidden=true;}else{document.querySelector('.title').classList.remove('title');}
try{var pictureURL=URL.createObjectURL(data.metadata.picture);var picture=document.getElementById('picture');picture.hidden=false;picture.style.backgroundImage='url('+pictureURL+')';}
catch(e){console.error('Couldn\'t set picture:',e);}}
preview.src=URL.createObjectURL(data.blob);preview.addEventListener('error',function(){showError('play-error-title','play-error-desc',callback.bind(null,'error'));});function updateCheckIcon(str){var checkIcon=null;if(document.getElementById('softkeyPanel')){checkIcon=document.getElementById('software-keys-center');checkIcon.textContent=str;}}
function cancelControl(){window.close();}
function checkControl(){var key='create-'+(checkBox.checked?'select':'deselect');updateCheckIcon(navigator.mozL10n.get(key));}
function showToast(msgId,msgArgs){var toast={messageL10nId:msgId,messageL10nArgs:msgArgs,useTransition:true};Toaster.showToast(toast);}
function saveTone(){document.getElementById('saving-overlay').hidden=false;var info={name:songtitle,subtitle:subtitle,blob:data.blob,filename:data.blob.name};var toneName="";window.customRingtones.add(info).then(function(tone){if(document.getElementById('default-switch').checked){return window.systemTones.set('ringtone',tone).then(function(){toneName=tone.name;return{toneID:tone.id,setAsDefault:true};});}
toneName=tone.name;return{toneID:tone.id,setAsDefault:false};}).then(function(details){var msgId=details.setAsDefault?'file-set-as-default-ringtone':'file-saved';showToast(msgId,{file:toneName});callback('save',details);},function(error){console.log('Error saving ringtone',error);showError('save-error-title','save-error-desc',callback.bind(null,'error'));});}
function createOptions(){var params={menuClassName:'menu-button',items:[{name:'Cancel',l10nId:'create-cancel',priority:1,method:cancelControl},{name:'Select',l10nId:'create-select',priority:2,method:checkControl},{name:'Save',l10nId:'create-save',priority:3,method:saveTone}]};var option=new SoftkeyPanel(params);option.show();}
window.addEventListener('keydown',function(e){if(e.key==='Backspace'){callback('cancel');e.preventDefault();}});createOptions();window.dispatchEvent(new Event("createRingtoneReady"));});}